#include "match.h"
#include <QDebug>
#include <QSettings>

Match::Match(QString hometeam, QString awayteam, QDateTime date, QObject *parent) :
    QObject(parent)
{
    QSettings settings("buliscores", "buliscores");
    m_league = settings.value("League", "1. Bundesliga").toString();
	
    m_date = date;

    m_homeTeam = hometeam;
    m_awayTeam = awayteam;
    m_homeScore = -1;
    m_awayScore = -1;

    m_homeEmblem = getEmblemByName(hometeam);
    m_awayEmblem = getEmblemByName(awayteam);
}


// TODO write team class that allows more attributes
// and aliases for team names
QIcon Match::getEmblemByName(QString team)
{
	QString icono = "/opt/buliscores/" + m_league + "/" + team + ".png";

    QIcon i ( icono );
	
	qDebug() << "ICONO: " << icono;

 
	/*if ( m_league == "1. Bundesliga" )
	{
		if (team == "Hannover 96") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Hannover.png");
		} else if (team == "FC St. Pauli") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/St.Pauli.png");
		} else if (team == "Hamburger SV") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Hamburg.png");
		} else if (team == "1. FC Kaiserslautern") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Kaiserslautern.png");
		} else if (team == "1. FSV Mainz 05") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Mainz.png");
		} else if (team == "1899 Hoffenheim") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Hoffenheim.png");
		} else if (team == "Borussia M'gladbach") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Moenchengladbach.png");
		} else if (team == "VfL Wolfsburg") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Wolfsburg.png");
		} else if (team == "SC Freiburg") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Freiburg.png");
		} else if (team == "1. FC Kln") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Koeln.png");
		} else if (team == "1. FC Nrnberg") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Nuernberg.png");
		} else if (team == "FC Schalke 04") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Schalke.png");
		} else if (team == "VfB Stuttgart") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Stuttgart.png");
		} else if (team == "Eintracht Frankfurt") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Frankfurt.png");
		} else if (team == "Bayer Leverkusen") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Leverkusen.png");
		} else if (team == "Werder Bremen") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Bremen.png");
		} else if (team == "Borussia Dortmund") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Dortmund.png");
		} else if (team == "Bayern Mnchen") {
		    i = QIcon(":/1.Bundesliga/images/teams/Bundesliga1/Bayern.png");
	    } else {
	        i = QIcon();
	    }
	}
	else if ( m_league == "2. Bundesliga" )
	{
		if (team == "Arminia Bielefeld") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Bielefeld.png");
		} else if (team == "SpVgg Greuther Frth") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/GreutherFuerth.png");
		} else if (team == "FSV Frankfurt") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Frankfurt.png");
		} else if (team == "Hertha BSC") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/HerthaBerlin.png");
		} else if (team == "Karlsruher SC") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Karlsruhe.png");
		} else if (team == "Energie Cottbus") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Cottbus.png");
		} else if (team == "Alemannia Aachen") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Aachen.png");
		} else if (team == "Rot-Wei Oberhausen") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Oberhausen.png");
		} else if (team == "Fortuna Dsseldorf") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Duesseldorf.png");
		} else if (team == "1. FC Union Berlin") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/UnionBerlin.png");
		} else if (team == "Erzgebirge Aue") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Aue.png");
		} else if (team == "SC Paderborn 07") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Paderborn.png");
		} else if (team == "FC Ingolstadt 04") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Ingolstadt.png");
		} else if (team == "1860 Mnchen") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Muenchen.png");
		} else if (team == "VfL Bochum") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Bochum.png");
		} else if (team == "VfL Osnabrck") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Osnabrueck.png");
		} else if (team == "FC Augsburg") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Augsburg.png");
		} else if (team == "MSV Duisburg") {
		    i = QIcon(":/2.Bundesliga/images/teams/Bundesliga2/Duisburg.png");
	    } else {
	        i = QIcon();
	    }
	}
	else if ( m_league == "Argentina" )
	{
		if (team == "All Boys") {
		    i = QIcon(":/Argentina/images/teams/argentina/Allboys.png");
		} else if (team == "Argentinos Juniors") {
		    i = QIcon(":/Argentina/images/teams/argentina/Argentinos.png");
		} else if (team == "Arsenal") {
		    i = QIcon(":/Argentina/images/teams/argentina/Arsenal.png");
		} else if (team == "Banfield") {
		    i = QIcon(":/Argentina/images/teams/argentina/Banfield.png");
		} else if (team == "Boca Juniors") {
		    i = QIcon(":/Argentina/images/teams/argentina/Boca.png");
		} else if (team == "Colon") {
		    i = QIcon(":/Argentina/images/teams/argentina/Colon.png");
		} else if (team == "Estudiantes") {
		    i = QIcon(":/Argentina/images/teams/argentina/Estudiantes.png");
		} else if (team == "Gimnasia de La Plata") {
		    i = QIcon(":/Argentina/images/teams/argentina/Gimnasia.png");
		} else if (team == "Godoy Cruz") {
		    i = QIcon(":/Argentina/images/teams/argentina/Godoy.png");
		} else if (team == "Huracan") {
		    i = QIcon(":/Argentina/images/teams/argentina/Huracan.png");
		} else if (team == "Independiente") {
		    i = QIcon(":/Argentina/images/teams/argentina/Independiente.png");
		} else if (team == "Lanus") {
		    i = QIcon(":/Argentina/images/teams/argentina/Lanus.png");
		} else if (team == "Newells Old Boys") {
		    i = QIcon(":/Argentina/images/teams/argentina/NOB.png");
		} else if (team == "Olimpo") {
		    i = QIcon(":/Argentina/images/teams/argentina/Olimpo.png");
		} else if (team == "Quilmes") {
		    i = QIcon(":/Argentina/images/teams/argentina/Quilmes.png");
		} else if (team == "Racing") {
		    i = QIcon(":/Argentina/images/teams/argentina/Racing.png");
		} else if (team == "River Plate") {
		    i = QIcon(":/Argentina/images/teams/argentina/River.png");
		} else if (team == "San Lorenzo") {
		    i = QIcon(":/Argentina/images/teams/argentina/Sanlorenzo.png");
		} else if (team == "Tigre") {
		    i = QIcon(":/Argentina/images/teams/argentina/Tigre.png");
		} else if (team == "Velez Sarsfield") {
		    i = QIcon(":/Argentina/images/teams/argentina/Velez.png");
	    } else {
	        i = QIcon();
	    }
	}
	else if ( m_league == "La Liga" )
	{
		if (team == "Villarreal") {
		    i = QIcon(":/spain/images/teams/spain/vil.png");
		} else if (team == "Valencia") {
		    i = QIcon(":/spain/images/teams/spain/val.png");
		} else if (team == "Almeria") {
		    i = QIcon(":/spain/images/teams/spain/alm.png");
		} else if (team == "Barcelona") {
		    i = QIcon(":/spain/images/teams/spain/bar.png");
		} else if (team == "Real Madrid") {
		    i = QIcon(":/spain/images/teams/spain/mad.png");
		} else if (team == "Athletic Bilbao") {
		    i = QIcon(":/spain/images/teams/spain/bil.png");
		} else if (team == "Deportivo") {
		    i = QIcon(":/spain/images/teams/spain/dep.png");
		} else if (team == "Malaga") {
		    i = QIcon(":/spain/images/teams/spain/mal.png");
		} else if (team == "Levante") {
		    i = QIcon(":/spain/images/teams/spain/lev.png");
		} else if (team == "Racing") {
		    i = QIcon(":/spain/images/teams/spain/rac.png");
		} else if (team == "Espanyol") {
		    i = QIcon(":/spain/images/teams/spain/esp.png");
		} else if (team == "Hercules") {
		    i = QIcon(":/spain/images/teams/spain/her.png");
		} else if (team == "Osasuna") {
		    i = QIcon(":/spain/images/teams/spain/osa.png");
		} else if (team == "Sporting de Gijon") {
		    i = QIcon(":/spain/images/teams/spain/gij.png");
		} else if (team == "Sevilla") {
		    i = QIcon(":/spain/images/teams/spain/sev.png");
		} else if (team == "Mallorca") {
		    i = QIcon(":/spain/images/teams/spain/mca.png");
		} else if (team == "Real Sociedad") {
		    i = QIcon(":/spain/images/teams/spain/soc.png");
		} else if (team == "Getafe") {
			i = QIcon(":/spain/images/teams/spain/get.png");
		} else if (team == "Zaragoza") {
		    i = QIcon(":/spain/images/teams/spain/zar.png");
		} else if (team == "Atletico Madrid") {
		    i = QIcon(":/spain/images/teams/spain/atm.png");
	    } else {
	        i = QIcon();
	    }
	}
	else if ( m_league == "Eredivisie" )
	{
		if (team == "SBV Excelsior") {
		    i = QIcon(":/dutch/images/teams/dutch/excelsior.png");
		} else if (team == "VVV-Venlo") {
		    i = QIcon(":/dutch/images/teams/dutch/vvv.png");
		} else if (team == "Twente") {
		    i = QIcon(":/dutch/images/teams/dutch/fc_twente.png");
		} else if (team == "Alkmaar") {
		    i = QIcon(":/dutch/images/teams/dutch/az.png");
		} else if (team == "Vitesse") {
		    i = QIcon(":/dutch/images/teams/dutch/vitesse.png");
		} else if (team == "Heracles Almelo") {
		    i = QIcon(":/dutch/images/teams/dutch/heracles.png");
		} else if (team == "Ajax") {
		    i = QIcon(":/dutch/images/teams/dutch/ajax.png");
		} else if (team == "PSV") {
		    i = QIcon(":/dutch/images/teams/dutch/psv.png");
		} else if (team == "Groningen") {
		    i = QIcon(":/dutch/images/teams/dutch/fc_groningen.png");
		} else if (team == "Feyenoord") {
		    i = QIcon(":/dutch/images/teams/dutch/feyenoord.png");
		} else if (team == "Heerenveen") {
		    i = QIcon(":/dutch/images/teams/dutch/sc_heerenveen.png");
		} else if (team == "Willem II") {
		    i = QIcon(":/dutch/images/teams/dutch/willem_II.png");
		} else if (team == "Den Haag") {
		    i = QIcon(":/dutch/images/teams/dutch/haag.png");
		} else if (team == "NAC") {
		    i = QIcon(":/dutch/images/teams/dutch/nac.png");
		} else if (team == "Utrecht") {
		    i = QIcon(":/dutch/images/teams/dutch/fc_utrecht.png");
		} else if (team == "NEC") {
		    i = QIcon(":/dutch/images/teams/dutch/nec.png");
		} else if (team == "De Graafschap") {
		    i = QIcon(":/dutch/images/teams/dutch/de_graafschap.png");
		} else if (team == "Roda") {
		    i = QIcon(":/dutch/images/teams/dutch/roda_jc.png");
	    } else {
	        i = QIcon();
	    }
	}
	else if ( m_league == "tipp3 Bundesliga" )
	{
		if (team == "Sturm Graz") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/Graz.png");
		} else if (team == "Austria Wien") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/AustriaWien.png");
		} else if (team == "SV Mattersburg") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/Mattersburg.png");
		} else if (team == "RB Salzburg") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/Salzburg.png");
		} else if (team == "LASK Linz") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/Linz.png");
		} else if (team == "Rapid Wien") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/RapidWien.png");
		} else if (team == "SV Ried") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/Ried.png");
		} else if (team == "Kapfenberger SV") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/Kapfenberg.png");
		} else if (team == "Wacker Innsbruck") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/Innsbruck.png");
		} else if (team == "SC Wiener Neustadt") {
		    i = QIcon(":/tipp3Liga/images/teams/tipp3Liga/WienerNeustadt.gif");
		} else {
	        i = QIcon();
	    }
	}*/
    return i;
}

void Match::setScore(int home, int away, bool notifyWatchers)
{
    bool changed = false;
    int oldhomescore = m_homeScore;
    int oldawayscore = m_awayScore;

    if (m_homeScore != home) {
        m_homeScore = home;
        if (oldhomescore != -1) {
            m_lastHomeGoal = QDateTime::currentDateTime();
        }
        changed = true;
    }

    if (m_awayScore != away) {
        m_awayScore = away;
        if (oldawayscore != -1) {
            m_lastAwayGoal = QDateTime::currentDateTime();
        }
        changed = true;
    }

    if (changed && notifyWatchers) {
        emit scoreChanged(oldhomescore, oldawayscore,
                          home, away);
    }
}

void Match::setState(MatchState state, bool notifyWatchers) {
    if (m_state != state) {
        m_state = state;
        if (notifyWatchers) {
            emit stateChanged(state);
        }
    }
}
